/* Program to work in black and white 
   Lists calls etc   Version 1.0, 14.9.02
*/

#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

main(argc, argv)

     int argc;
    char *argv[];

{     /*main*/
  Display *display;
  Display *ConnectToServer();
  Window  rootwindow,window;
  Window OpenWindow();
  int screen;
  int x,y,width,height;
  Visual *visual=CopyFromParent;

  GC  gc;
  GC  CreateGC();
  XEvent event;
  int count,nclose;
  int mtba,ma,mb,mc,m1,m2,m3,m4;
  long mla,mlb;
  float ua,ub,uc,u1,u2,u3,u4;

  display= ConnectToServer( (char *) NULL, &screen, &rootwindow);

  printXInfo(display, screen);

  x=10;y=30;width=300;height=300;

  window=OpenWindow( display, rootwindow, x,y,width,height,
		     BlackPixel(display,screen),
		     WhitePixel(display,screen),
                     ExposureMask,
                     visual);

  mla=BlackPixel(display,screen); 
  mlb=WhitePixel(display,screen); 
  printf("Black pixel mla=%ld   White pixel %ld \n",mla,mlb); 

  /*mla=0xf800;mlb=0x1f;    uncomment to get different colours! */
  gc=CreateGC(display, window,mla,mlb); 

  XMapRaised(display,window);
  XFlush(display);

  printf("Blank window should have appeared. Press key to continue ");
  scanf("%d", &nclose);
  printf("About to start writing to window. \n ");
  printf("Move another window across it at most 10 times to close  \n");

  count=0;

  while (count< 10) {
    XNextEvent(display,&event);

    if(event.type=Expose) 
      
      /*   Redraw(display,window,gc); */

   XDrawLine(display,window,gc,1,1,100,100);
   XDrawLine(display,window,gc,100,1,1,100);
   XFillRectangle(display,window,gc,100,100,100,100);

  XFlush(display); 
    count++;
    printf(" %d ",count); }

  printf("Closing window ...\n ");
    XCloseDisplay (display);
}

  printXInfo( dis, screen)

  Display *dis;
  int screen;
{
  int depth;
  printf("X Information.  X Window System: ");
  printf("%s version %d  \n", ServerVendor(dis),VendorRelease(dis));

  printf("X protocol %d.%d \n", ProtocolVersion(dis),ProtocolRevision(dis)); 

  depth= DefaultDepth(dis, screen);
  printf("Colour depth is %d   ", depth);
  printf("Width = %d   ",DisplayWidth(dis, screen) );
  printf("Height = %d  \n",DisplayHeight(dis, screen) );
  printf("Black = %d \n",BlackPixel(dis, screen) );
  printf("White = %d \n",WhitePixel(dis, screen) );

  printf("Display [%s] \n", DisplayString(dis) );

}
 
Display *ConnectToServer( display_name, screen, rootwindow)

     char display_name[];
     int *screen;
     Window *rootwindow;

{
  Display *display;

  display= XOpenDisplay(display_name);

  if( display== (Display *) NULL)
    {printf("Failed to connect to X server %s \n",XDisplayName(display_name));
    printf("Fatal error in routine ConnectToServer \n");  
    exit(1);}
  else {  printf("Connected to server \n");}
  *screen = DefaultScreen (display);
  *rootwindow= RootWindow(display,*screen);
  return(display);
} 

  Window  OpenWindow( display, parent, x,y,width,height,
            bordercolor, backcolor, event_mask, visual)

  Display *display;
  Window parent;
  int x,y,width,height;
  unsigned long bordercolor, backcolor;
  unsigned long event_mask;
  Visual *visual;

{ 
  Window window;
  XSetWindowAttributes attributes;
  unsigned long  attr_mask;

  attributes.event_mask=event_mask;
  attributes.border_pixel= bordercolor;
  attributes.background_pixel= backcolor;
  attr_mask= CWEventMask | CWBackPixel | CWBorderPixel;

  window=XCreateWindow(display,parent,x,y,width,height,
		       2,
                       CopyFromParent,
                       InputOutput,
                       visual,attr_mask, &attributes); 
   
  return(window);
}

GC CreateGC(display,drawable,forecolor,backcolor)

  Display *display;
  Drawable drawable;
  unsigned long forecolor,backcolor;

{ 
  XGCValues xgcvalues;
   GC gc;
   xgcvalues.foreground=forecolor;
   xgcvalues.background=backcolor;

   gc=XCreateGC(display,drawable,
		(GCForeground|GCBackground), &xgcvalues);

   return gc;
}

SetUpVisual(display, screen, visual,depth)

 Display *display;
 int screen;
 Visual **visual;
  int *depth;

{
  int no_vis;
  XVisualInfo *visual_array, visual_template;
  int status=False;

  /*  if (DefaultVisual(display,screen)->class == TrueColor)
      { printf("SetUpVisual (visual.c) True Color is default \n"); }*/

  *depth=DefaultDepth(display,screen);
  *visual=DefaultVisual(display,screen);

  /*  printf("Screen %d Depth %d Status %d \n",screen, depth,status);
      printf("SetUpVisual (visual.c) About to return \n");*/

}
