/* Voter Model   5.8.03 
   Version 1.1
   Program by Martin Barlow vm.c
   Called by xw.c          */          

#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define RBASE 0x0800
#define GBASE 0x0020
#define BBASE 0x0001

#define ran4() (random() >>29)    /* 0,1,2,3  */
#define ran2() (random() >>30)    /* 0 or 1  */
#define fran() ((float) random()/(float) 0x7fffffff)
#define rans() (random() >>8)    /* random colours */
/* If you have 24 color planes you should delete the line above
and replace it with 
#define rans() (random())   */


#define SC 512  
#define SQ 1  /* Size of each block  */
#define OFF 20

drawp(dis,win,gc,xmax,ymax)

  Display *dis;
  Window win;
  GC  gc;
  int xmax,ymax;

{
  unsigned long  xs[SC][SC];
  long ia;
  int i,j,k,na,nb,nc,nd,ix,iy,jx,jy,iscan,sc;
  unsigned long rb,gb,bb,ca,cb;
  float ua,ub,uc;

  srandom(1234);
  sc=SC/SQ;

    XFlush(dis);
    for(i=0;i<20000;i++){
      point(dis,win,gc,400,400,0);}

  for(i=0;i<sc;i++){ 
  for(j=0;j<sc;j++){ 
    xs[i][j]=rans(); }}

    for(i=0;i<sc;i++){ 
    for(j=0;j<sc;j++){
    frect(dis,win,gc,OFF+SQ*i,OFF+SQ*j,SQ,SQ,xs[i][j]); }}

     XFlush(dis); 

     while(1){

     ix=fran()*sc;iy=fran()*sc;jx=ix;jy=iy;
     na=ran4();
     if(na==0) { jx=ix+1; if(jx==sc){jx=0;} }     
     if(na==1) { jy=iy+1; if(jy==sc){jy=0;} }     
     if(na==2) { jx=ix-1; if(jx<0){jx=sc-1;} }     
     if(na==3) { jy=iy-1; if(jy<0){jy=sc-1;} }     
     xs[ix][iy]=xs[jx][jy];
 
     frect(dis,win,gc,OFF+SQ*ix,OFF+SQ*iy,SQ,SQ,xs[ix][iy]); }
}


