/* xw.c Simple routines to open window
 Program then calls drawp which can draw in window using routines
 point, line, etc  
 This program works using TrueColor
 Program by Martin Barlow          
 Version 1.1  4.9.2002    */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define WIDTH 600
#define HEIGHT 600

main()

{     /*main*/
  Display *display;
  Window  rootwindow,window;
  int screen;
  int x,y,width,height;
  Visual *visual;
  GC  gc;
  XGCValues xgcvalues;
  XEvent event;
  int count,depth,status;
  unsigned long attr_mask,event_mask,forecolor,backcolor;
  XSetWindowAttributes attributes;

  display= XOpenDisplay(  (char *) NULL );
  if( display== (Display *) NULL)  
  { printf("Error in opening display \n");exit(1);}

  screen = DefaultScreen(display);
  rootwindow= RootWindow(display,screen);
  visual=DefaultVisual(display,screen);

  x=10;y=10;width=WIDTH;height=HEIGHT;

  window=XCreateSimpleWindow(display,rootwindow,x,y,width,height,2,0,
     WhitePixel(display,screen));
 
   gc=XCreateGC(display,window,(GCForeground|GCBackground),&xgcvalues);

  XMapRaised(display,window);
  XFlush(display);

  /* User provided program to actually draw  */
  drawp(display,window,gc,width,height);
}

/* Some easy routines for quick drawing of rectangles etc */

lrect(dis,win,gc,x,y,w,h,col)

Display *dis;
Window win;
GC gc;
int x,y,h,w;
unsigned long col;

{  XSetForeground(dis,gc,col);
 XDrawRectangle(dis,win,gc,x,y,w,h); }

frect(dis,win,gc,x,y,w,h,col)

Display *dis;
Window win;
GC gc;
int x,y,h,w;
unsigned long col;

{ XSetForeground(dis,gc,col);
 XFillRectangle(dis,win,gc,x,y,w,h);}

line(dis,win,gc,xs,ys,xe,ye,col)

Display *dis;
Window win;
GC gc;
int xs,ys,xe,ye;
unsigned long col;

{ XSetForeground(dis,gc,col);
 XDrawLine(dis,win,gc,xs,ys,xe,ye); }

point(dis,win,gc,x,y,col)

Display *dis;
Window win;
GC gc;
int x,y;
unsigned long col;

{ XSetForeground(dis,gc,col);
 XDrawPoint(dis,win,gc,x,y); }
